Index: issm/branches/trunk-jpl-damage/src/c/solvers/solver_newton.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solver_newton.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solver_newton.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -17,5 +17,5 @@
 	int    num_unstable_constraints;
 	int    count;
-	double kmax;
+	IssmDouble kmax;
 	Matrix* Kff = NULL;
 	Matrix* Kfs    = NULL;
@@ -70,13 +70,13 @@
 			bool max_iteration_state=false;
 			int tempStep=1;
-			double tempTime=1.0;
+			IssmDouble tempTime=1.0;
 			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
 		}
 		if(count>=max_nonlinear_iterations){
-			_printf_(true,"   maximum number of Newton iterations (%i) exceeded\n",max_nonlinear_iterations); 
+			_pprintLine_("   maximum number of Newton iterations (" << max_nonlinear_iterations << ") exceeded"); 
 			bool max_iteration_state=true;
 			int tempStep=1;
-			double tempTime=1.0;
+			IssmDouble tempTime=1.0;
 			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
@@ -100,5 +100,5 @@
 	}
 
-	_printf_(VerboseConvergence(),"\n   total number of iterations: %i\n",count-1);
+	if(VerboseConvergence()) _pprintLine_("\n   total number of iterations: " << count-1);
 
 	/*clean-up*/
Index: issm/branches/trunk-jpl-damage/src/c/solvers/solver_nonlinear.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solver_nonlinear.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solver_nonlinear.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -73,5 +73,5 @@
 
 		ConstraintsStatex(&constraints_converged, &num_unstable_constraints, femmodel->elements,femmodel->nodes,femmodel->vertices,loads,femmodel->materials,femmodel->parameters);
-		_printf_(VerboseConvergence(),"   number of unstable constraints: %i\n",num_unstable_constraints);
+		if(VerboseConvergence()) _pprintLine_("   number of unstable constraints: " << num_unstable_constraints);
 
 		//rift convergence
@@ -88,10 +88,10 @@
 			bool max_iteration_state=false;
 			int tempStep=1;
-			double tempTime=1.0;
+			IssmDouble tempTime=1.0;
 			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
 		}
 		if(count>=max_nonlinear_iterations){
-			_printf_(true,"   maximum number of nonlinear iterations (%i) exceeded\n",max_nonlinear_iterations); 
+			_pprintLine_("   maximum number of nonlinear iterations (" << max_nonlinear_iterations << ") exceeded"); 
 			converged=true;
 			InputUpdateFromConstantx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,converged,ConvergedEnum);
@@ -99,5 +99,5 @@
 			bool max_iteration_state=true;
 			int tempStep=1;
-			double tempTime=1.0;
+			IssmDouble tempTime=1.0;
 			femmodel->results->AddObject(new BoolExternalResult(femmodel->results->Size()+1, MaxIterationConvergenceFlagEnum, max_iteration_state, tempStep, tempTime));
 			break;
@@ -105,5 +105,5 @@
 	}
 
-	_printf_(VerboseConvergence(),"\n   total number of iterations: %i\n",count-1);
+	if(VerboseConvergence()) _pprintLine_("\n   total number of iterations: " << count-1);
 
 	/*clean-up*/
Index: issm/branches/trunk-jpl-damage/src/c/solvers/solver_stokescoupling_nonlinear.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solver_stokescoupling_nonlinear.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solver_stokescoupling_nonlinear.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
 #include "../io/io.h"
@@ -91,5 +91,5 @@
 		if(converged==true)break;
 		if(count>=max_nonlinear_iterations){
-			_printf_(true,"   maximum number of iterations (%i) exceeded\n",max_nonlinear_iterations); 
+			_pprintLine_("   maximum number of iterations (" << max_nonlinear_iterations << ") exceeded"); 
 			break;
 		}
Index: issm/branches/trunk-jpl-damage/src/c/solvers/solver_thermal_nonlinear.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solver_thermal_nonlinear.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 #include "../toolkits/toolkits.h"
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 #include "../EnumDefinitions/EnumDefinitions.h"
@@ -16,5 +16,5 @@
 	Vector* tf_old=NULL; 
 	Vector* ys=NULL; 
-	double melting_offset;
+	IssmDouble melting_offset;
 
 	/*intermediary: */
@@ -47,5 +47,5 @@
 	converged=false;
 
-	_printf_(VerboseSolution(),"%s\n","starting direct shooting method");
+	if(VerboseSolution()) _pprintLine_("starting direct shooting method");
 	InputUpdateFromConstantx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,true,ResetPenaltiesEnum);
 	InputUpdateFromConstantx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,false,ConvergedEnum);
@@ -66,9 +66,9 @@
 
 		if (!converged){
-			_printf_(VerboseConvergence(),"%s%i\n","   #unstable constraints = ",num_unstable_constraints);
+			if(VerboseConvergence()) _pprintLine_("   #unstable constraints = " << num_unstable_constraints);
 			if (num_unstable_constraints <= thermal_penalty_threshold)converged=true;
 			if (count>=thermal_maxiter){
 				converged=true;
-				_printf_(true,"   maximum number of iterations (%i) exceeded\n",thermal_maxiter); 
+				_pprintLine_("   maximum number of iterations (" << thermal_maxiter << ") exceeded"); 
 			}
 		}
Index: issm/branches/trunk-jpl-damage/src/c/solvers/solvers.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/solvers/solvers.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/solvers/solvers.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define SOLVERS_H_
 
-#include "../objects/objects.h"
+#include "../classes/objects/objects.h"
 #include "../io/io.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqMat.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqMat.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqMat.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -19,5 +19,5 @@
 
 /*SeqMat constructors and destructor*/
-/*FUNCTION SeqMat::SeqMat(){{{1*/
+/*FUNCTION SeqMat::SeqMat(){{{*/
 SeqMat::SeqMat(){
 
@@ -27,5 +27,5 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::SeqMat(int M,int N){{{1*/
+/*FUNCTION SeqMat::SeqMat(int M,int N){{{*/
 SeqMat::SeqMat(int pM,int pN){
 
@@ -33,18 +33,18 @@
 	this->N=pN;
 	this->matrix=NULL;
-	if(M*N) this->matrix=(double*)xcalloc(pM*pN,sizeof(double));
-}
-/*}}}*/
-/*FUNCTION SeqMat::SeqMat(int M,int N, double sparsity){{{1*/
-SeqMat::SeqMat(int pM,int pN, double sparsity){
-
-	this->M=pM;
-	this->N=pN;
-	this->matrix=NULL;
-	if(M*N) this->matrix=(double*)xcalloc(pM*pN,sizeof(double));
-}
-/*}}}*/
-/*FUNCTION SeqMat(double* serial_mat,int M,int N,double sparsity){{{1*/
-SeqMat::SeqMat(double* serial_mat,int pM,int pN,double sparsity){
+	if(M*N) this->matrix=xNewZeroInit<IssmDouble>(pM*pN);
+}
+/*}}}*/
+/*FUNCTION SeqMat::SeqMat(int M,int N, IssmDouble sparsity){{{*/
+SeqMat::SeqMat(int pM,int pN, IssmDouble sparsity){
+
+	this->M=pM;
+	this->N=pN;
+	this->matrix=NULL;
+	if(M*N) this->matrix=xNewZeroInit<IssmDouble>(pM*pN);
+}
+/*}}}*/
+/*FUNCTION SeqMat::SeqMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){{{*/
+SeqMat::SeqMat(IssmDouble* serial_mat,int pM,int pN,IssmDouble sparsity){
 
 	int i,j;
@@ -54,11 +54,11 @@
 	this->matrix=NULL;
 	if(M*N){
-		this->matrix=(double*)xcalloc(pM*pN,sizeof(double));
-		memcpy(this->matrix,serial_mat,pM*pN*sizeof(double));
-	}
-
-}
-/*}}}*/
-/*FUNCTION SeqMat::SeqMat(int M,int N, int connectivity, int numberofdofspernode){{{1*/
+		this->matrix=xNewZeroInit<IssmDouble>(pM*pN);
+		xMemCpy<IssmDouble>(this->matrix,serial_mat,pM*pN);
+	}
+
+}
+/*}}}*/
+/*FUNCTION SeqMat::SeqMat(int M,int N, int connectivity, int numberofdofspernode){{{*/
 SeqMat::SeqMat(int pM,int pN, int connectivity,int numberofdofspernode){
 
@@ -66,11 +66,11 @@
 	this->N=pN;
 	this->matrix=NULL;
-	if(M*N)this->matrix=(double*)xcalloc(pM*pN,sizeof(double));
-}
-/*}}}*/
-/*FUNCTION SeqMat::~SeqMat(){{{1*/
+	if(M*N) this->matrix=xNewZeroInit<IssmDouble>(pM*pN);
+}
+/*}}}*/
+/*FUNCTION SeqMat::~SeqMat(){{{*/
 SeqMat::~SeqMat(){
 
-	xfree((void**)&this->matrix);
+	xDelete<IssmDouble>(this->matrix);
 	M=0;
 	N=0;
@@ -79,18 +79,18 @@
 
 /*SeqMat specific routines: */
-/*FUNCTION SeqMat::Echo{{{1*/
+/*FUNCTION SeqMat::Echo{{{*/
 void SeqMat::Echo(void){
 
 	int i,j;
-	printf("SeqMat size %i-%i\n",this->M,this->N);
+	_printLine_("SeqMat size " << this->M << "-" << this->N);
 	for(i=0;i<M;i++){
 		for(j=0;j<N;j++){
-			printf("%g ",this->matrix[N*i+j]);
+			_printString_(this->matrix[N*i+j] << " ");
 		}
-		printf("\n");
-	}
-}
-/*}}}*/
-/*FUNCTION SeqMat::Assemble{{{1*/
+		_printLine_("");
+	}
+}
+/*}}}*/
+/*FUNCTION SeqMat::Assemble{{{*/
 void SeqMat::Assemble(void){
 		
@@ -99,9 +99,9 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::Norm{{{1*/
-double SeqMat::Norm(NormMode mode){
-
-	double norm;
-	double absolute;
+/*FUNCTION SeqMat::Norm{{{*/
+IssmDouble SeqMat::Norm(NormMode mode){
+
+	IssmDouble norm;
+	IssmDouble absolute;
 	int i,j;
 
@@ -119,10 +119,10 @@
 			break;
 		default:
-			_error_("unknown norm !");
-			break;
-	}
-}
-/*}}}*/
-/*FUNCTION SeqMat::GetSize{{{1*/
+			_error2_("unknown norm !");
+			break;
+	}
+}
+/*}}}*/
+/*FUNCTION SeqMat::GetSize{{{*/
 void SeqMat::GetSize(int* pM,int* pN){
 
@@ -132,5 +132,5 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::GetLocalSize{{{1*/
+/*FUNCTION SeqMat::GetLocalSize{{{*/
 void SeqMat::GetLocalSize(int* pM,int* pN){
 	
@@ -140,16 +140,16 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::MatMult{{{1*/
+/*FUNCTION SeqMat::MatMult{{{*/
 void SeqMat::MatMult(SeqVec* X,SeqVec* AX){
 
 	int i,j;
 	int XM,AXM;
-	double dummy;
+	IssmDouble dummy;
 
 	X->GetSize(&XM);
 	AX->GetSize(&AXM);
 
-	if(M!=AXM)_error_("A and AX should have the same number of rows!");
-	if(N!=XM)_error_("A and X should have the same number of columns!");
+	if(M!=AXM)_error2_("A and AX should have the same number of rows!");
+	if(N!=XM)_error2_("A and X should have the same number of columns!");
 
 	for(i=0;i<M;i++){
@@ -163,8 +163,8 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::Duplicate{{{1*/
+/*FUNCTION SeqMat::Duplicate{{{*/
 SeqMat* SeqMat::Duplicate(void){
 
-	double dummy=0;
+	IssmDouble dummy=0;
 
 	return new SeqMat(this->matrix,this->M,this->N,dummy);
@@ -172,12 +172,12 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::ToSerial{{{1*/
-double* SeqMat::ToSerial(void){
-
-	double* buffer=NULL;
+/*FUNCTION SeqMat::ToSerial{{{*/
+IssmDouble* SeqMat::ToSerial(void){
+
+	IssmDouble* buffer=NULL;
 
 	if(this->M*this->N){
-		buffer=(double*)xmalloc(this->M*this->N*sizeof(double));
-		memcpy(buffer,this->matrix,this->M*this->N*sizeof(double));
+		buffer=xNew<IssmDouble>(this->M*this->N);
+		xMemCpy<IssmDouble>(buffer,this->matrix,this->M*this->N);
 	}
 	return buffer;
@@ -185,6 +185,6 @@
 }
 /*}}}*/
-/*FUNCTION SeqMat::SetValues{{{1*/
-void SeqMat::SetValues(int m,int* idxm,int n,int* idxn,double* values,InsMode mode){
+/*FUNCTION SeqMat::SetValues{{{*/
+void SeqMat::SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode){
 	
 	int i,j;
@@ -197,11 +197,11 @@
 			break;
 		default:
-			_error_("unknown insert mode!");
-			break;
-	}
-
-}
-/*}}}*/
-/*FUNCTION SeqMat::Convert{{{1*/
+			_error2_("unknown insert mode!");
+			break;
+	}
+
+}
+/*}}}*/
+/*FUNCTION SeqMat::Convert{{{*/
 void SeqMat::Convert(MatrixType type){
 
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqMat.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqMat.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqMat.h	(revision 12878)
@@ -1,4 +1,4 @@
 /*!\file:  SeqMat.h
- * \brief wrapper to SeqMat objects, which are just wrappers to a simple double* buffer.
+ * \brief wrapper to SeqMat objects, which are just wrappers to a simple IssmDouble* buffer.
  */ 
 
@@ -7,5 +7,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -24,24 +24,24 @@
 	
 		int M,N; 
-		double* matrix; 
+		IssmDouble* matrix; 
 
-		/*SeqMat constructors, destructors {{{1*/
+		/*SeqMat constructors, destructors {{{*/
 		SeqMat();
 		SeqMat(int M,int N);
-		SeqMat(int M,int N,double sparsity);
-		SeqMat(double* serial_mat,int M,int N,double sparsity);
+		SeqMat(int M,int N,IssmDouble sparsity);
+		SeqMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity);
 		SeqMat(int M,int N,int connectivity,int numberofdofspernode);
 		~SeqMat();
 		/*}}}*/
-		/*SeqMat specific routines {{{1*/
+		/*SeqMat specific routines {{{*/
 		void Echo(void);
 		void Assemble(void);
-		double Norm(NormMode norm_type);
+		IssmDouble Norm(NormMode norm_type);
 		void GetSize(int* pM,int* pN);
 		void GetLocalSize(int* pM,int* pN);
 		void MatMult(SeqVec* X,SeqVec* AX);
 		SeqMat* Duplicate(void);
-		double* ToSerial(void);
-		void SetValues(int m,int* idxm,int n,int* idxn,double* values,InsMode mode);
+		IssmDouble* ToSerial(void);
+		void SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode);
 		void Convert(MatrixType type);
 		/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqVec.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqVec.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqVec.cpp	(revision 12878)
@@ -4,5 +4,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -19,5 +19,5 @@
 
 /*SeqVec constructors and destructor*/
-/*FUNCTION SeqVec::SeqVec(){{{1*/
+/*FUNCTION SeqVec::SeqVec(){{{*/
 SeqVec::SeqVec(){
 
@@ -26,14 +26,14 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::SeqVec(int M,bool fromlocalsize){{{1*/
+/*FUNCTION SeqVec::SeqVec(int M,bool fromlocalsize){{{*/
 SeqVec::SeqVec(int pM,bool fromlocalsize){
 
 	this->M=pM;
 	this->vector=NULL;
-	if(this->M) this->vector=(double*)xcalloc(pM,sizeof(double));
-}
-/*}}}*/
-/*FUNCTION SeqVec::SeqVec(double* serial_vec,int M){{{1*/
-SeqVec::SeqVec(double* buffer,int pM){
+	if(this->M) this->vector=xNewZeroInit<IssmDouble>(pM);
+}
+/*}}}*/
+/*FUNCTION SeqVec::SeqVec(IssmDouble* serial_vec,int M){{{*/
+SeqVec::SeqVec(IssmDouble* buffer,int pM){
 
 	int i,j;
@@ -42,12 +42,12 @@
 	this->vector=NULL;
 	if(this->M){
-		this->vector=(double*)xcalloc(pM,sizeof(double));
-		memcpy(this->vector,buffer,pM*sizeof(double));
-	}
-}
-/*}}}*/
-		/*FUNCTION SeqVec::~SeqVec(){{{1*/
+		this->vector=xNew<IssmDouble>(pM);
+		xMemCpy<IssmDouble>(this->vector,buffer,pM);
+	}
+}
+/*}}}*/
+		/*FUNCTION SeqVec::~SeqVec(){{{*/
 SeqVec::~SeqVec(){
-	xfree((void**)&this->vector);
+	xDelete<IssmDouble>(this->vector);
 	M=0;
 }
@@ -55,16 +55,16 @@
 
 /*SeqVec specific routines: */
-/*FUNCTION SeqVec::Echo{{{1*/
+/*FUNCTION SeqVec::Echo{{{*/
 void SeqVec::Echo(void){
 
 	int i;
-	printf("SeqVec size %i\n",this->M);
+	_printLine_("SeqVec size " << this->M);
 	for(i=0;i<M;i++){
-		printf("%g\n ",vector[i]);
-	}
-}
-/*}}}*/
-
-/*FUNCTION SeqVec::Assemble{{{1*/
+		_printString_(vector[i] << "\n ");
+	}
+}
+/*}}}*/
+
+/*FUNCTION SeqVec::Assemble{{{*/
 void SeqVec::Assemble(void){
 		
@@ -73,6 +73,6 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::SetValues{{{1*/
-void SeqVec::SetValues(int ssize, int* list, double* values, InsMode mode){
+/*FUNCTION SeqVec::SetValues{{{*/
+void SeqVec::SetValues(int ssize, int* list, IssmDouble* values, InsMode mode){
 	
 	int i;
@@ -85,12 +85,12 @@
 			break;
 		default:
-			_error_("unknown insert mode!");
-			break;
-	}
-
-}
-/*}}}*/
-/*FUNCTION SeqVec::SetValue{{{1*/
-void SeqVec::SetValue(int dof, double value, InsMode mode){
+			_error2_("unknown insert mode!");
+			break;
+	}
+
+}
+/*}}}*/
+/*FUNCTION SeqVec::SetValue{{{*/
+void SeqVec::SetValue(int dof, IssmDouble value, InsMode mode){
 
 	switch(mode){
@@ -102,11 +102,11 @@
 			break;
 		default:
-			_error_("unknown insert mode!");
-			break;
-	}
-}
-/*}}}*/
-/*FUNCTION SeqVec::GetValue{{{1*/
-void SeqVec::GetValue(double* pvalue,int dof){
+			_error2_("unknown insert mode!");
+			break;
+	}
+}
+/*}}}*/
+/*FUNCTION SeqVec::GetValue{{{*/
+void SeqVec::GetValue(IssmDouble* pvalue,int dof){
 
 	*pvalue=this->vector[dof];
@@ -115,5 +115,5 @@
 /*}}}*/
 		
-/*FUNCTION SeqVec::GetSize{{{1*/
+/*FUNCTION SeqVec::GetSize{{{*/
 void SeqVec::GetSize(int* pM){
 
@@ -122,5 +122,5 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::GetLocalSize{{{1*/
+/*FUNCTION SeqVec::GetLocalSize{{{*/
 void SeqVec::GetLocalSize(int* pM){
 	
@@ -129,5 +129,5 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::Duplicate{{{1*/
+/*FUNCTION SeqVec::Duplicate{{{*/
 SeqVec* SeqVec::Duplicate(void){
 	
@@ -136,6 +136,6 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::Set{{{1*/
-void SeqVec::Set(double value){
+/*FUNCTION SeqVec::Set{{{*/
+void SeqVec::Set(IssmDouble value){
 
 	int i;
@@ -144,6 +144,6 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::AXPY{{{1*/
-void SeqVec::AXPY(SeqVec* X, double a){
+/*FUNCTION SeqVec::AXPY{{{*/
+void SeqVec::AXPY(SeqVec* X, IssmDouble a){
 
 	int i;
@@ -154,6 +154,6 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::AYPX{{{1*/
-void SeqVec::AYPX(SeqVec* X, double a){
+/*FUNCTION SeqVec::AYPX{{{*/
+void SeqVec::AYPX(SeqVec* X, IssmDouble a){
 	
 	int i;
@@ -164,12 +164,12 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::ToMPISerial{{{1*/
-double* SeqVec::ToMPISerial(void){
-
-	double* buffer=NULL;
+/*FUNCTION SeqVec::ToMPISerial{{{*/
+IssmDouble* SeqVec::ToMPISerial(void){
+
+	IssmDouble* buffer=NULL;
 
 	if(this->M){
-		buffer=(double*)xmalloc(this->M*sizeof(double));
-		memcpy(buffer,this->vector,this->M*sizeof(double));
+		buffer=xNew<IssmDouble>(this->M);
+		xMemCpy<IssmDouble>(buffer,this->vector,this->M);
 	}
 	return buffer;
@@ -177,5 +177,5 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::Copy{{{1*/
+/*FUNCTION SeqVec::Copy{{{*/
 void SeqVec::Copy(SeqVec* to){
 
@@ -187,8 +187,8 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::Norm{{{1*/
-double SeqVec::Norm(NormMode mode){
-
-	double norm;
+/*FUNCTION SeqVec::Norm{{{*/
+IssmDouble SeqVec::Norm(NormMode mode){
+
+	IssmDouble norm;
 	int i;
 
@@ -204,11 +204,11 @@
 			break;
 		default:
-			_error_("unknown norm !");
-			break;
-	}
-}
-/*}}}*/
-/*FUNCTION SeqVec::Scale{{{1*/
-void SeqVec::Scale(double scale_factor){
+			_error2_("unknown norm !");
+			break;
+	}
+}
+/*}}}*/
+/*FUNCTION SeqVec::Scale{{{*/
+void SeqVec::Scale(IssmDouble scale_factor){
 
 	int i;
@@ -217,10 +217,10 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::Dot{{{1*/
-double SeqVec::Dot(SeqVec* input){
-
-	int i;
-
-	double dot=0;
+/*FUNCTION SeqVec::Dot{{{*/
+IssmDouble SeqVec::Dot(SeqVec* input){
+
+	int i;
+
+	IssmDouble dot=0;
 	for(i=0;i<this->M;i++)dot+=this->vector[i]*input->vector[i];
 	return dot;
@@ -228,5 +228,5 @@
 }
 /*}}}*/
-/*FUNCTION SeqVec::PointwiseDivide{{{1*/
+/*FUNCTION SeqVec::PointwiseDivide{{{*/
 void SeqVec::PointwiseDivide(SeqVec* x,SeqVec* y){
 
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqVec.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqVec.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/issm/SeqVec.h	(revision 12878)
@@ -1,4 +1,4 @@
 /*!\file:  SeqVec.h
- * \brief wrapper to our SeqVec object, which is just a wrapper to a double* 
+ * \brief wrapper to our SeqVec object, which is just a wrapper to a IssmDouble* 
  */ 
 
@@ -7,5 +7,5 @@
 
 /*Headers:*/
-/*{{{1*/
+/*{{{*/
 #ifdef HAVE_CONFIG_H
 	#include <config.h>
@@ -22,31 +22,31 @@
 	public:
 	
-		double* vector;
+		IssmDouble* vector;
 		int M;
 
-		/*SeqVec constructors, destructors {{{1*/
+		/*SeqVec constructors, destructors {{{*/
 		SeqVec();
 		SeqVec(int M,bool fromlocalsize=false);
-		SeqVec(double* buffer, int M);
+		SeqVec(IssmDouble* buffer, int M);
 		~SeqVec();
 		/*}}}*/
-		/*SeqVec specific routines {{{1*/
+		/*SeqVec specific routines {{{*/
 		void Echo(void);
 		void Assemble(void);
-		void SetValues(int ssize, int* list, double* values, InsMode mode);
-		void SetValue(int dof, double value, InsMode  mode);
-		void GetValue(double* pvalue, int dof);
+		void SetValues(int ssize, int* list, IssmDouble* values, InsMode mode);
+		void SetValue(int dof, IssmDouble value, InsMode  mode);
+		void GetValue(IssmDouble* pvalue, int dof);
 		void GetSize(int* pM);
 		void GetLocalSize(int* pM);
 		SeqVec* Duplicate(void);
-		void Set(double value);
-		void AXPY(SeqVec* X, double a);
-		void AYPX(SeqVec* X, double a);
-		double* ToMPISerial(void);
+		void Set(IssmDouble value);
+		void AXPY(SeqVec* X, IssmDouble a);
+		void AYPX(SeqVec* X, IssmDouble a);
+		IssmDouble* ToMPISerial(void);
 		void Copy(SeqVec* to);
-		double Norm(NormMode norm_type);
-		void Scale(double scale_factor);
+		IssmDouble Norm(NormMode norm_type);
+		void Scale(IssmDouble scale_factor);
 		void PointwiseDivide(SeqVec* x,SeqVec* y);
-		double Dot(SeqVec* vector);
+		IssmDouble Dot(SeqVec* vector);
 		/*}}}*/
 };
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/issm/issmtoolkit.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/issm/issmtoolkit.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/issm/issmtoolkit.h	(revision 12878)
@@ -6,4 +6,6 @@
 #define _ISSM_TOOLKIT_H_
 
+#include "../../include/include.h"
+
 #include "./SeqMat.h"
 #include "./SeqVec.h"
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/metis/patches/METIS_PartMeshNodalPatch.cpp	(revision 12878)
@@ -13,5 +13,5 @@
 	METIS_PartMeshNodal(pnumberofelements,pnumberofnodes, index, petype, pnumflag, pnum_procs, pedgecut, epart, npart); 
 	#elif _METIS_VERSION_ == 5
-	/*This interface is heavily changed. More options, different way of meshing, etc ...: */ 
+	/*This interface is heavily changed. More options, different ways of meshing, etc ...: */ 
 	int i;
 
@@ -21,6 +21,4 @@
 	idx_t  k=0;
 	real_t* tpwgts=NULL;
-
-
 
 	/*setup options: */
@@ -40,7 +38,6 @@
 	options[METIS_OPTION_NCUTS]   = 1;
 
-
 	/*create eptr: */
-	eptr=(idx_t*)xmalloc((*pnumberofelements+1)*sizeof(idx_t));
+	eptr=xNew<idx_t>((*pnumberofelements+1));
 	eptr[0]=0;
 	for(i=0;i<*pnumberofelements;i++){
@@ -49,19 +46,19 @@
 	}
 
-
 	/*create tpwgts: */
-	tpwgts=(real_t*)xmalloc(*pnum_procs*sizeof(real_t));
+	tpwgts=xNew<real_t>(*pnum_procs);
 	for(i=0;i<*pnum_procs;i++){
 		tpwgts[i]=1.0/(*pnum_procs);
 	}
 
+	METIS_PartMeshNodal(pnumberofelements,pnumberofnodes, eptr, index,
+			NULL, NULL, pnum_procs, tpwgts, options, &objval,epart, npart);
 
-	METIS_PartMeshNodal(pnumberofelements,pnumberofnodes, eptr, index,
-			NULL, NULL, pnum_procs, tpwgts, options, &objval,
-			epart, npart);
-	
+	/*clean-up*/
+	xDelete<idx_t>(eptr);
+	xDelete<real_t>(tpwgts);
 
 	#else
-	_error_("METIS version not supported yet");
+	_error2_("METIS version not supported yet");
 	#endif
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/mpi/patches/DetermineLocalSize.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/mpi/patches/DetermineLocalSize.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/mpi/patches/DetermineLocalSize.cpp	(revision 12878)
@@ -5,6 +5,4 @@
 #include <stdio.h>
 #include <math.h>
-
-
 #include "../../../shared/shared.h"
 
@@ -24,8 +22,7 @@
 	
 	/*We are  not bound by any library, just use what seems most logical*/
-	num_local_rows=(int*)xmalloc(num_procs*sizeof(int));    
+	num_local_rows=xNew<int>(num_procs);    
 
 	for (i=0;i<num_procs;i++){
-
 		/*Here, we use floor. We under distribute rows. The rows 
 		  left  are then redistributed, therefore resulting in a 
@@ -39,9 +36,8 @@
 		num_local_rows[i]++;
 	}
-
 	local_size=num_local_rows[my_rank];
 	
 	/*free ressources: */
-	xfree((void**)&num_local_rows);
+	xDelete<int>(num_local_rows);
 
 	/*return size: */
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/mpi/patches/MPI_Boundariesfromrange.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/mpi/patches/MPI_Boundariesfromrange.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/mpi/patches/MPI_Boundariesfromrange.cpp	(revision 12878)
@@ -20,7 +20,6 @@
 
 	/*Gather all range values into allranges, for all nodes*/
-	allranges=(int*)xmalloc(num_procs*sizeof(int));
+	allranges=xNew<int>(num_procs);
 	MPI_Allgather(&range,1,MPI_INT,allranges,1,MPI_INT,MPI_COMM_WORLD);
-
 
 	/*From all ranges, get lower row and upper row*/
@@ -31,12 +30,9 @@
 		upper_row=upper_row+allranges[i];
 	}
-	
-	/*free: */
-	xfree((void**)&allranges);
 
 	/*Assign output pointers: */
+	xDelete<int>(allranges);
 	*plower_row=lower_row;
 	*pupper_row=upper_row;
-
 	return 1;
 }
Index: issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscMat.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/toolkits/petsc/objects/PetscMat.cpp	(revision 12878)
@@ -0,0 +1,170 @@
+/*!\file PetscMat.cpp
+ * \brief: implementation of the PetscMat object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../petscincludes.h"
+#include "../../../shared/shared.h"
+
+/*}}}*/
+
+/*PetscMat constructors and destructor*/
+/*FUNCTION PetscMat::PetscMat(){{{*/
+PetscMat::PetscMat(){
+	this->matrix=NULL;
+	#ifdef _HAVE_ADOLC_
+	this->amatrix=NULL;
+	#endif
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(int M,int N){{{*/
+PetscMat::PetscMat(int M,int N){
+
+	this->matrix=NewMat(M,N);
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(int M,int N, IssmDouble sparsity){{{*/
+PetscMat::PetscMat(int M,int N, IssmDouble sparsity){
+
+	this->matrix=NewMat(M,N,sparsity);
+}
+/*}}}*/
+/*FUNCTION PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){{{*/
+PetscMat::PetscMat(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity){
+
+	int     i;
+	int* idxm=NULL;
+	int* idxn=NULL;
+	
+	if(M)idxm=xNew<int>(M);
+	if(N)idxn=xNew<int>(N);
+
+	for(i=0;i<M;i++)idxm[i]=i;
+	for(i=0;i<N;i++)idxn[i]=i;
+
+
+	this->matrix=NewMat(M,N,sparsity);
+	MatSetValues(this->matrix,M,idxm,N,idxn,serial_mat,INSERT_VALUES);
+	MatAssemblyBegin(this->matrix,MAT_FINAL_ASSEMBLY);
+	MatAssemblyEnd(this->matrix,MAT_FINAL_ASSEMBLY);
+
+	xDelete<int>(idxm);
+	xDelete<int>(idxn);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::PetscMat(int M,int N, int connectivity, int numberofdofspernode){{{*/
+PetscMat::PetscMat(int M,int N, int connectivity,int numberofdofspernode){
+	
+	this->matrix=NewMat(M,N,connectivity,numberofdofspernode);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::~PetscMat(){{{*/
+PetscMat::~PetscMat(){
+	MatFree(&this->matrix);
+}
+/*}}}*/
+
+/*PetscMat specific routines: */
+/*FUNCTION PetscMat::Echo{{{*/
+void PetscMat::Echo(void){
+
+	MatView(this->matrix,PETSC_VIEWER_STDOUT_WORLD);
+}
+/*}}}*/
+/*FUNCTION PetscMat::Assemble{{{*/
+void PetscMat::Assemble(void){
+
+	_assert_(this->matrix);
+	MatAssemblyBegin(this->matrix,MAT_FINAL_ASSEMBLY);
+	MatAssemblyEnd(this->matrix,MAT_FINAL_ASSEMBLY);
+	#if _PETSC_MAJOR_ == 2 
+		MatCompress(this->matrix);
+	#endif
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::Norm{{{*/
+IssmDouble PetscMat::Norm(NormMode mode){
+
+
+	IssmDouble norm=0;
+	_assert_(this->matrix);
+	MatNorm(this->matrix,ISSMToPetscNormMode(mode),&norm);
+	
+	return norm;
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::GetSize{{{*/
+void PetscMat::GetSize(int* pM,int* pN){
+
+	_assert_(this->matrix);
+	MatGetSize(this->matrix,pM,pN);
+}
+/*}}}*/
+/*FUNCTION PetscMat::GetLocalSize{{{*/
+void PetscMat::GetLocalSize(int* pM,int* pN){
+
+	_assert_(this->matrix);
+	MatGetLocalSize(this->matrix,pM,pN);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::MatMult{{{*/
+void PetscMat::MatMult(PetscVec* X,PetscVec* AX){
+
+	_assert_(this->matrix);
+	_assert_(X->vector);
+	MatMultPatch(this->matrix,X->vector,AX->vector);
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::Duplicate{{{*/
+PetscMat* PetscMat::Duplicate(void){
+
+	PetscMat* output=NULL;
+
+	output=new PetscMat();
+	_assert_(this->matrix);
+	MatDuplicate(this->matrix,MAT_COPY_VALUES,&output->matrix);
+
+	return output;
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::ToSerial{{{*/
+IssmDouble* PetscMat::ToSerial(void){
+
+	 IssmDouble* output=NULL;
+
+	 MatToSerial(&output,this->matrix);
+	 return output;
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::SetValues{{{*/
+void PetscMat::SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode){
+
+	MatSetValues(this->matrix,m,idxm,n,idxn,values,ISSMToPetscInsertMode(mode));
+
+}
+/*}}}*/
+/*FUNCTION PetscMat::Convert{{{*/
+void PetscMat::Convert(MatrixType type){
+
+	MatConvert(this->matrix,ISSMToPetscMatrixType(type),MAT_REUSE_MATRIX,&this->matrix);
+
+}
+/*}}}*/
